'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSource = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.unwrap = unwrap;
exports.bindActionCreator = bindActionCreator;
exports.bindActionCreators = bindActionCreators;

var _createSource = require('./createSource');

var _createSource2 = _interopRequireDefault(_createSource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.createSource = _createSource2.default;


var IS_ITERABLE_SENTINEL = '@@__IMMUTABLE_ITERABLE__@@';
var IS_RECORD_SENTINEL = '@@__IMMUTABLE_RECORD__@@';

function unwrap(state) {
  var isImmutable = state[IS_ITERABLE_SENTINEL] || state[IS_RECORD_SENTINEL];
  var wrapperName = isImmutable ? state.get('_autoWrapper') : state._autoWrapper;
  if (wrapperName) {
    if (isImmutable) {
      return unwrap(state.get(wrapperName));
    } else {
      return unwrap(state[state._autoWrapper]);
    }
  } else {
    return state;
  }
}

function bindActionCreator(actionCreator, dispatch) {
  return function () {
    return dispatch(actionCreator.apply(undefined, arguments));
  };
}

function bindActionCreators(actionCreators, dispatch) {
  var keys = Object.keys(actionCreators);
  var boundActionCreators = {};
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    var actionCreator = actionCreators[key];
    if (typeof actionCreator === 'function') {
      boundActionCreators[key] = bindActionCreator(actionCreator, dispatch);
    } else if ((typeof actionCreator === 'undefined' ? 'undefined' : _typeof(actionCreator)) === 'object') {
      boundActionCreators[key] = bindActionCreators(actionCreator, dispatch);
    }
  }
  return boundActionCreators;
}
//# sourceMappingURL=index.js.map